#include "generic.h"
// #include "getopt.h"
// #include <sys/timeb.h>
#include <math.h>
#include <stdio.h>
#include <stdlib.h>
#include <iostream.h>
#include <math.h>

inline void SetPixelColor(SDL_Surface *screen, int x, int y, unsigned char red, unsigned char green, unsigned char blue)
{
  ((unsigned char*)(screen->pixels))[x*3+0 + y*screen->pitch] = red;
  ((unsigned char*)(screen->pixels))[x*3+1 + y*screen->pitch] = green;
  ((unsigned char*)(screen->pixels))[x*3+2 + y*screen->pitch] = blue;
} // SetPixelColor

inline void SetPixel(SDL_Surface* screen, int x, int y)
{
  SetPixelColor(screen, x, y, 255, 255, 255);
} // SetPixel

inline void swap(int &a, int &b)
{
  int t;

  t = a;
  a = b;
  b = t;
} // swap

int main(int argc, char** argv)
{
    SDL_Surface      *screen, *backup_screen;
    SDL_Event        event;
    SDL_Rect         dst_rect, full_image_rect, scrolled_rect, location;
    int              window_width, window_height, thumb_height, thumb_border_size;
    long             pixel_set = 0;

    window_width = 512; window_height = 512;

    if(SDL_Init(SDL_INIT_VIDEO) < 0) {
	cerr << "Could not initialize SDL video" << endl;
	exit(-1);
    } // if
    atexit(SDL_Quit);

    Uint32 flags = 0;

    // flags |= SDL_FULLSCREEN;

    screen = SDL_SetVideoMode(window_width, window_height, 24, flags);

    if(!screen) {
	cerr << "could not SetVideoMode() - abort" << endl;
	exit(-1);
    } // if

    int x, y, a, b;
    double dist;

    a = 150; b = 100;
    y = b;

    dist = 4*b*b - 4*a*a*b + ((double)(a*a));

    // first region

    for(x = 0; a*a*(y-0.5) > b*b*(x+1); x++) {

      if(dist > 0) { // choose SE
	y--;
	dist += 4*b*b*(2*x+3) + 4*a*a*(2-2*y);
      } // if
      else {         // choose S
	dist += 4*b*b*(2*x+3);
      } // else
	
      SetPixel(screen, x+180, y+160);
      SetPixel(screen, x+180, -y+160);
      SetPixel(screen, -x+180, y+160);
      SetPixel(screen, -x+180, -y+160);
    } // for

    // second region

    dist = ...;
    x = a;

    for(y = 0; ... < ...; y++) {

      if(dist < 0) { // choose SE
	...
      } // if
      else {         // choose S
	x--;
	...
      } // else
	
      SetPixel(screen, x+180, y+160);
      SetPixel(screen, x+180, -y+160);
      SetPixel(screen, -x+180, y+160);
      SetPixel(screen, -x+180, -y+160);
    } // for

    SDL_UnlockSurface(screen);
    SDL_UpdateRect(screen, 0, 0, window_width, window_height);
    SDL_LockSurface(screen);

    for(;;) {

	if((SDL_PollEvent(&event) == 0) && (event.type == SDL_KEYDOWN)) 
	    goto exit_app;

	switch(event.type) {
		
	    case SDL_MOUSEMOTION:	      
		break;
		
	    case SDL_MOUSEBUTTONDOWN:
		break;
		
	    case SDL_MOUSEBUTTONUP:
		break;
		
	    case SDL_KEYDOWN:
		
		switch(event.key.keysym.sym) {
		    
		    case 27:
		    case 'q':
		    case 'Q':
			goto exit_app;
			
		    default:
			break;
		} // switch
	} // switch

    } // for
	    
 exit_app:

    SDL_UnlockSurface(screen);	    
    SDL_FreeSurface(screen);

    exit(0);
} // main
